<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: ThreadSafeStorage&lt; Key, Value &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classThreadSafeStorage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ThreadSafeStorage&lt; Key, Value &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a3e0a8c75eb3cb90bf4ca7e7e762c18c8"><td class="memItemLeft" align="right" valign="top"><a id="a3e0a8c75eb3cb90bf4ca7e7e762c18c8"></a>
std::list&lt; Key &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>get_valid_keys</b> ()</td></tr>
<tr class="separator:a3e0a8c75eb3cb90bf4ca7e7e762c18c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9e0c17043a5d327ca5a10ffb624ca42"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classThreadSafeStorage.html#ae9e0c17043a5d327ca5a10ffb624ca42">insert_valid_key</a> (Key const &amp;k)</td></tr>
<tr class="separator:ae9e0c17043a5d327ca5a10ffb624ca42"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f4857ce15275f638f525db39d5e6672"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classThreadSafeStorage.html#a2f4857ce15275f638f525db39d5e6672">remove_valid_key</a> (Key const &amp;k)</td></tr>
<tr class="separator:a2f4857ce15275f638f525db39d5e6672"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af991b7ee741ae33a5e9b95b67272d40b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classThreadSafeStorage.html#af991b7ee741ae33a5e9b95b67272d40b">contains_key</a> (Key const &amp;k)</td></tr>
<tr class="separator:af991b7ee741ae33a5e9b95b67272d40b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbaa4e96c6b84196a052ea0444312c7c"><td class="memTemplParams" colspan="2"><a id="adbaa4e96c6b84196a052ea0444312c7c"></a>
template&lt;class Value2 &gt; </td></tr>
<tr class="memitem:adbaa4e96c6b84196a052ea0444312c7c"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>insert_new_message</b> (Key const &amp;k, Value2 &amp;&amp;v)</td></tr>
<tr class="separator:adbaa4e96c6b84196a052ea0444312c7c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e7f4eec339afc8ed34c111a24dd6b51"><td class="memItemLeft" align="right" valign="top"><a id="a0e7f4eec339afc8ed34c111a24dd6b51"></a>
std::list&lt; Value &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>get</b> (Key const &amp;k)</td></tr>
<tr class="separator:a0e7f4eec339afc8ed34c111a24dd6b51"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3828851215f106370bf86218a9939633"><td class="memItemLeft" align="right" valign="top"><a id="a3828851215f106370bf86218a9939633"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>delete_all</b> ()</td></tr>
<tr class="separator:a3828851215f106370bf86218a9939633"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e8a9c1c55a776718dc1b4dc98ba1c78"><td class="memItemLeft" align="right" valign="top"><a id="a4e8a9c1c55a776718dc1b4dc98ba1c78"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>empty</b> ()</td></tr>
<tr class="separator:a4e8a9c1c55a776718dc1b4dc98ba1c78"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a0fa60839f2eb0f00b2f289c66d197f99"><td class="memItemLeft" align="right" valign="top"><a id="a0fa60839f2eb0f00b2f289c66d197f99"></a>
std::mutex&#160;</td><td class="memItemRight" valign="bottom"><b>m_</b></td></tr>
<tr class="separator:a0fa60839f2eb0f00b2f289c66d197f99"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af991b7ee741ae33a5e9b95b67272d40b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af991b7ee741ae33a5e9b95b67272d40b">&#9670;&nbsp;</a></span>contains_key()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Key , class Value &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classThreadSafeStorage.html">ThreadSafeStorage</a>&lt; Key, Value &gt;::contains_key </td>
          <td>(</td>
          <td class="paramtype">Key const &amp;&#160;</td>
          <td class="paramname"><em>k</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Check if the provided key is contained in the set of valid keys. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">k</td><td>the key to find in the set of valid keys </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if the key is found, false otherwise </dd></dl>

</div>
</div>
<a id="ae9e0c17043a5d327ca5a10ffb624ca42"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9e0c17043a5d327ca5a10ffb624ca42">&#9670;&nbsp;</a></span>insert_valid_key()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Key , class Value &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classThreadSafeStorage.html">ThreadSafeStorage</a>&lt; Key, Value &gt;::insert_valid_key </td>
          <td>(</td>
          <td class="paramtype">Key const &amp;&#160;</td>
          <td class="paramname"><em>k</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Add a new key to the set of valid keys </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">k</td><td>the key to add </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2f4857ce15275f638f525db39d5e6672"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2f4857ce15275f638f525db39d5e6672">&#9670;&nbsp;</a></span>remove_valid_key()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Key , class Value &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classThreadSafeStorage.html">ThreadSafeStorage</a>&lt; Key, Value &gt;::remove_valid_key </td>
          <td>(</td>
          <td class="paramtype">Key const &amp;&#160;</td>
          <td class="paramname"><em>k</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Remove a key from the set of valid keys. As a side effect, all pairs in the unordered_multimap are removed</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">k</td><td>the key to remove </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/builds/eclipse/oniro-core/eddie/linux/communication/include/<a class="el" href="common_8h_source.html">common.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
